//
// Esempio di utilizzo delle eccezioni
//

#include <values.h>
#include "Exception2.H"


MyShort::MyShort(long l) throw (RangeExcp)
{
  if ((l > MAXSHORT) || (l < MINSHORT))
    throw MyShort::RangeExcp('C');	// Eccezione se il risultato non e` un
					// MyShort
  v = (short)l;
}


// Operazione di divisione fra short
MyShort operator/ (MyShort a, MyShort b) throw (Errors)
{
  if (b.v == 0)
    throw DIVIDEBYZERO; 	// Eccezione se il divisore e` nullo

  return(a.v / b.v);
}



// Operazione di moltiplicazione fra MyShort
MyShort operator* (MyShort a, MyShort b) throw (MyShort::RangeExcp)
{
  long c = a.v * b.v;

  if ((c > MAXSHORT) || (c < MINSHORT))
    throw MyShort::RangeExcp('*');	// Eccezione se il risultato non e` uno
					// short
  return(c);
}


// Operazione di somma fra MyShort
MyShort operator+ (MyShort a, MyShort b) throw (MyShort::RangeExcp)
{
  long c = a.v + b.v;

  if ((c > MAXSHORT) || (c < MINSHORT))
    throw MyShort::RangeExcp('+');	// Eccezione se il risultato non e` uno
					// short
  return(c);
}


// Operazione di sottrazione fra MyShort
MyShort operator- (MyShort a, MyShort b) throw (Errors)
{
  long c = a.v - b.v;

  if (c < 0)		// Lanciamo una eccezione se il risultato e` negativo
    throw STRANGE;

  return(c);
}


// Operazione di inversione
MyShort operator- (MyShort a) throw (int)
{
  if (a.v == 0)
    throw 666;		// Eccezione se il numero da invertire e` zero

  return(-a.v);
}


// Estrazione da Stream
istream& operator>> (istream& ci, MyShort& m) throw (MyShort::RangeExcp)
{
  long c;
  ci >> c;
  if ((c > MAXSHORT) || (c < MINSHORT))
    throw MyShort::RangeExcp('E');	// Eccezione se il valore letto non e`
					// uno short.
  m.v = c;

  return(ci);
}


// Inserimento da Stream
ostream& operator<< (ostream& co, const MyShort& m)
{
  co << m.v;

  return(co);
}
