//
// Esempio di utilizzo delle eccezioni.
// Provare con le seguenti combinazioni:
//	   0	  -12
//	  12	   13
//	  12	    0
//	 1234	 1234
//	23456	23456
//	34567

#include <iostream.h>
#include "Exception2.H"


void loop();


main()
{
  try {
    cout << "Inizia il programma!" << endl;
    loop();
  }
  catch (Errors err) {
    if (err == STRANGE)
      cerr << "Si e` verificata una eccezione strana!" << endl
	   << "(risultato negativo di una sottrazione)" << endl;
  }
  catch (...) {		// Raccoglie qualunque altro tipo di eccezione
    cerr << "Eccezione eccezionale!!" << endl;
  }

  cout << "Fine del programma" << endl;

  exit(0);
}


void loop()
{
  MyShort a, b;
  char r;

  cout << "Inizia il loop" <<  endl;

  do {
    try {
      cout << "Dammi il primo operando: ";
      cin >> a;

      cout << "Dammi il secondo operando: ";
      cin >> b;

      cout << "La somma fra i due numeri e`: " << a + b << endl;
      cout << "La divisione fra i due numeri e`: " << a / b << endl;
      cout << "La moltiplicazione fra i due numeri e`: " << a * b << endl;
      cout << "La sottrazione fra i due numeri e`: " << a - b << endl;
      cout << "L'inverso del primo numero e`: " << -a << endl;
      cout << "L'inverso del secondo numero e`: " << -b << endl;
    }
    catch (MyShort::RangeExcp r) {
      cerr << "Il risultato dell'operazione \"" << r.op 
	   << "\" e` al di fuori del range di valori ammissibili" << endl;
    }
    catch (Errors e) {
      if (e == DIVIDEBYZERO)
	cerr << "Attenzione: il divisore e` nullo" << endl;
      else
	throw;	// Se non e` una divisione per zero, rilanciamo l'eccezione
    }


    cout << "Un'altra operazione?" << endl;
    cin >> r;

  } while ((r != 'n') && (r != 'N'));

  cout << "Fine del loop" << endl;
}
